#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

#define x first
#define y second

std::vector<std::pair<int, int>> v;
std::vector<std::pair<int, int>> b;
std::vector<std::pair<int, int>> e;


int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n;
    std::cin >> n;
    for(int i = 0; i < n; i++) {
        int a, b;
        std::cin >> a >> b;
        v.push_back({a, b});
    }
    std::sort(std::begin(v), std::end(v));
    b.push_back({v[0].x, 0});
    for(int i = 1; i < v.size(); i++) {
        if(v[i].x != v[i-1].x) {
            e.push_back({v[i-1].x, i-1});
            b.push_back({v[i].x, i});
        }
    }
    e.push_back({v[v.size() - 1].x, (int)v.size() - 1});
    int m;
    std::cin >> m;
    for(int i = 0; i < m; i++) {
        int _x1, _y1, _x2, _y2;
        std::cin >> _x1 >> _y1 >> _x2 >> _y2;
        int x1 = std::min(_x1, _x2),
            x2 = std::max(_x1, _x2),
            y1 = std::min(_y1, _y2),
            y2 = std::max(_y1, _y2);
        int cnt = 0;
        int begin = 0;
        int end = 0;
        for(int i = 0; i < b.size(); i++) {
            if(b[i].x <= x1) {
                begin = b[i].y;
            }
            if(b[i].x >= x2 || i == b.size() - 1) {
                end = e[i].y;
                break;
            }
        }
        for(int i = begin; i <= end; i++) {
            if(y1 <= v[i].y && y2 >= v[i].y && x1 <= v[i].x && x2 >= v[i].x)
                cnt++;
        }
        std::cout << cnt << "\n";
    }
    return 0;
}
