#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

#define x first
#define y second

std::vector<std::pair<int, int>> v;
std::vector<std::pair<int, int>> v1;
std::vector<std::pair<std::pair<int, int>, std::pair<int, int>>> t;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n;
    std::cin >> n;
    v.reserve(n);
    for(int i = 0; i < n; i++) {
        int a, b;
        std::cin >> a >> b;
        v.push_back({a, b});
    }
    int m;
    std::cin >> m;
    t.reserve(m);
    int minx = 1e6 + 1, miny = 1e6 + 1, maxx = -1, maxy = -1;
    for(int i = 0; i < m; i++) {
        int x1, y1, x2, y2;
        std::cin >> x1 >> y1 >> x2 >> y2;
        t.push_back({{std::min(x1, x2), std::min(y1, y2)}, {std::max(x1, x2), std::max(y1, y2)}});
        minx = std::min(minx, x1);
        minx = std::min(minx, x2);
        miny = std::min(miny, y1);
        miny = std::min(miny, y2);
        maxx = std::max(maxx, x1);
        maxx = std::max(maxx, x2);
        maxy = std::max(maxy, y1);
        maxy = std::max(maxy, y2);
    }
    v1.reserve(n);
    for(auto &x: v) {
        if(x.x >= minx && x.x <= maxx && x.y >= miny && x.y <= maxy)
            v1.push_back(x);
    }
    std::sort(std::begin(v1), std::end(v1));
    for(auto &x: t) {
        int cnt = 0;
        for(auto &y:v1) {
            if(y.x > x.y.x)
                break;
            if(y.x >= x.x.x && y.y >= x.x.y && y.y <= x.y.y)
                cnt++;
        }
        std::cout << cnt << "\n";
    }
    return 0;
}
