#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

pair <int, int> A[2005];

bool cmp (pair <int, int> a, pair <int, int> b)
{
    if (a.first != b.first)
    {
        return a.first > b.first;
    }
    return a.second > b.second;
}

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> A[i].first >> A[i].second;
    }

    sort(A, A + n, cmp);

    /*cout << "--------\n";
    for (int i = 0; i < n; ++i)
    {
        cout << A[i].first << ' ' << A[i].second << '\n';
    }
    cout << "--------\n";*/

    int d;
    cin >> d;

    vector <int> used;
    int l = 0;
    for (int i = 0; i < n and l < d; ++i)
    {
        used.push_back(i);
        l += A[i].first;
    }

    if (l < d)
    {
        cout << "0\n";
        return 0;
    }

    int res = n - used.size();
    for (int i = used.size() - 1; i >= 0; --i)
    {
        if (l >= d or l + A[used[i]].second >= d)
        {
            ++res;
            l -= A[used[i]].first;
        }
    }

    cout << res << '\n';
    return 0;
}
