#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

pair <int, int> A[2005];
int idx[2005];

bool cmp (pair <int, int> a, pair <int, int> b)
{
    if (a.first != b.first)
    {
        return a.first > b.first;
    }
    return a.second > b.second;
}

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> A[i].first >> A[i].second;
    }

    int d;
    cin >> d;

    /*cout << "--------\n";
    for (int i = 0; i < n; ++i)
    {
        cout << A[i].first << ' ' << A[i].second << '\n';
    }
    cout << "--------\n";*/

    int sami = 0;
    vector <int> used;
    int l = 0;
    for (int i = 0; i < n; ++i)
    {
        if (A[i].first + A[i].second >= d)
        {
            swap (A[sami], A[i]);
            used.push_back(sami);
            l += A[sami].first;
            ++sami;
        }
    }

    sort(A + sami, A + n, cmp);

    for (int i = 0; i < n and l < d; ++i)
    {
        used.push_back(i);
        l += A[i].first;
    }

    if (l < d)
    {
        cout << "0\n";
        return 0;
    }

    int aaa = 0;
    //cout << res << '\n';
    for (int i = used.size() - 1; i >= sami; --i)
    {
        idx[i] = i;
    }

    do
    {
        int curr = 0;
        int ll = l;
        for (int i = used.size() - 1; i >= sami; --i)
        {
            if (ll + A[used[idx[i]]].second >= d)
            {
                ++curr;
                ll -= A[used[idx[i]]].first;
                //cout << res << ' ' << l << ' ' << A[used[i]].first << ' ' << A[used[i]].second << '\n';
            }
        }
        if (curr > aaa)
        {
            aaa = curr;
        }
    }
    while (next_permutation(idx + sami, idx + used.size()));

    cout << n - used.size() + sami + aaa << '\n';
    return 0;
}
