#include <iostream>
#include <algorithm>
using namespace std;
const int maxN=1e5+10;
int n,m;
struct point{
    int x,y;
}p[maxN];
struct rect{
    int x1,x2,y1,y2;
    int ind,cnt;
    rect(){
        cnt=0;
    }
}rects[maxN];
bool pointInRect(rect a,point p)
{
    if(p.x>=min(a.x1,a.x2) && p.x<=max(a.x1,a.x2) && p.y>=min(a.y1,a.y2) && p.y<=max(a.y1,a.y2))return 1;
    return 0;
}
bool cmpP(point a,point b)
{
    if(a.x!=b.x)return a.x < b.x;
    return a.y < b.y;
}
bool cmpR(rect a,rect b)
{
    if(a.x1!=b.x1)return a.x1 < b.x1;
    if(a.x2!=b.x2)return a.x2 < b.x2;
    return a.y1 < b.y1;
}
bool cmp(rect a,rect b)
{
    return a.ind <  b.ind;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int i,j;
    cin>>n;
    for(i=0;i<n;i++)
    {
        cin>>p[i].x>>p[i].y;
    }
    sort(p,p+n,cmpP);
    cin>>m;
    for(i=0;i<m;i++)
    {
        cin>>rects[i].x1>>rects[i].y1>>rects[i].x2>>rects[i].y2;
        rects[i].ind=i;
        if(rects[i].x2<rects[i].x1){
            swap(rects[i].x1,rects[i].x2);
            swap(rects[i].y1,rects[i].y2);
        }
    }
    sort(rects,rects+m,cmpR);
    int k=0;
    for(i=0;i<m;i++)
    {
        int cnt=0;
        while(p[k].x<rects[i].x1)k++;
        for(j=k;j<n;j++)
        {
            if(pointInRect(rects[i],p[j])==1)rects[i].cnt++;
        }
    }
    sort(rects,rects+m,cmp);
    for(i=0;i<m;i++)
    {
        cout<<rects[i].cnt<<endl;
    }
}
/**
6
9 2
2 3
8 6
3 6
5 3
5 8
3
6 9 9 8
2 3 5 8
10 7 4 3
*/
