#include <cstdio>
#include <iostream>
#include <algorithm>
using namespace std;

struct point
{
    int x,y,nom;
} points[100004];
struct rect
{
    int xl,xr,yd,yu;

    rect(){};
    rect(int a,int b,int c,int d)
    {
        xl=a,xr=b,yd=c,yu=d;
    }
} rects[100004];

bool cmp_x(point a,point b)
{
    return a.x<b.x;
}
bool cmp_y(point a,point b)
{
    return a.y<b.y;
}

int n,m,a,b,c,d;

int main()
{
    scanf("%d",&n);

    for(int i=0;i<n;i++)
    {
        scanf("%d%d",&points[i].x,&points[i].y);

        points[i].nom=i;
    }

    scanf("%d",&m);

    for(int i=0;i<m;i++)
    {
        scanf("%d%d%d%d",&a,&b,&c,&d);

        rects[i]=rect(min(a,c),max(a,c),min(b,d),max(b,d));
    }

    sort(points,points+n,cmp_x);

    for(int i=0;i<m;i++)
    {
        int le=0,ri=n-1,near_gr=0,near_sm=n-1,cnt=0;

        while(le<=ri)
        {
            int mid=(le+ri)/2;

            if(points[mid].x>=rects[i].xl)
            {
                ri=mid-1;
                near_gr=mid;
            }
            else if(points[mid].x<rects[i].xl)le=mid+1;
        }
        le=0,ri=n-1;
        while(le<=ri)
        {
            int mid=(le+ri)/2;

            if(points[mid].x<=rects[i].xr)
            {
                le=mid+1;
                near_sm=mid;
            }
            else if(points[mid].x>rects[i].xr)ri=mid-1;
        }
        for(int j=near_gr;j<=near_sm;j++)
            if(rects[i].yu>=points[j].y&&points[j].y>=rects[i].yd)cnt++;

        printf("%d\n",cnt);
    }

    return 0;
}
