#include <bits/stdc++.h>

using namespace std;

const int MAXC = 1e4;

struct point
{
    int x, y;
};

bool a[MAXC][MAXC];
int T[MAXC][MAXC];

int n;

void read_input()
{
    scanf("%d", &n);

    for(int i = 0; i < n; i++)
    {
        int x, y;
        scanf("%d %d", &x, &y);
        a[x][y]++;
    }
}

void make_table()
{
    T[1][1] = a[1][1];
    for(int i = 2; i < MAXC; i++)
    {
        T[1][i] = T[1][i - 1] + a[1][i];
        T[i][1] = T[i - 1][1] + a[i][1];
    }
    for(int i = 2; i < MAXC; i++)
    {
        for(int j = 2; j < MAXC; j++)
        {
            T[i][j] = T[i - 1][j] + T[i][j - 1] - T[i - 1][j - 1] + a[i][j];
        }
    }
}

void solve()
{
    int q;
    scanf("%d", &q);
    for(int i = 0; i < q; i++)
    {
        int x1, y1, x2, y2;
        point f; point s;
        scanf("%d %d %d %d", &f.x, &f.y, &s.x, &s.y);
        if(f.x < s.x)
        {
            swap(f, s);
        }
        if(f.y < s.y)
        {
            int temp = f.y;
            f.y = s.y;
            s.y = temp;
        }
        int ans = T[f.x][f.y] - T[f.x][s.y - 1] - T[s.x - 1][f.y] + T[s.x - 1][s.y - 1];
        printf("%d\n", ans);
    }
}

int main()
{
    read_input();
    make_table();
    solve();

    return 0;
}

/*
6
9 2
2 3
8 6
3 6
5 3
5 8
3
6 9 9 8
2 3 5 8
10 7 4 3
*/
