#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2000;

struct person
{
    int H, L;

    bool operator<(person other) const
    {
        return H / L > other.H / other.L;
    }
};

int n, d;
person p[MAXN];
int T[MAXN][MAXN];

int rec(int l, int r, int vis)
{
    if(l > r) return 0;
    if(T[l][r])
    {
        return T[l][r];
    }
    int ans = 0;
    if(vis + p[l].L >= d)
    {
        ans = max(ans, rec(l + 1, r, vis - p[l].H) + 1);
    }
    if(vis + p[r].L >= d)
    {
        ans = max(ans, rec(l, r - 1, vis - p[r].H) + 1);
    }
    return T[l][r] = ans;
}

int main()
{
    scanf("%d", &n);
    for(int i = 0; i < n; i++)
    {
        scanf("%d %d", &p[i].H, &p[i].L);
    }
    scanf("%d", &d);

    sort(p, p + n);

    int vis = 0;

    for(int i = 0; i < n; i++)
    {
        vis += p[i].H;
    }

    printf("%d\n", rec(0, n - 1, vis));

    return 0;
}

/*
6
6 7
3 1
8 5
8 4
4 2
10 5
30
*/

/*
2
10 4
5 2
20
*/
