#include <bits/stdc++.h>

using namespace std;

const int MAXC = 10000;

struct point
{
    int x, y;
};

int a[MAXC][MAXC];
int T[MAXC][MAXC];

int n;

void read_input()
{
    scanf("%d", &n);

    for(int i = 0; i < n; i++)
    {
        int x, y;
        scanf("%d %d", &x, &y);
        x++; y++;
        a[y][x] = 1;
    }
}

void make_table()
{
    T[1][1] = a[1][1];
    for(int i = 2; i < MAXC; i++)
    {
        T[1][i] = T[1][i - 1] + a[1][i];
        T[i][1] = T[i - 1][1] + a[i][1];
    }
    for(int i = 2; i < MAXC; i++)
    {
        for(int j = 2; j < MAXC; j++)
        {
            T[i][j] = T[i - 1][j] + T[i][j - 1] - T[i - 1][j - 1] + a[i][j];
        }
    }

    /*for(int i = 1; i < 11; i++)
    {
        for(int j = 1; j < 11; j++)
        {
            printf("%d ", a[i][j]);
        }
        printf("\n");
    }*/
}

void solve()
{
    int q;
    scanf("%d", &q);
    for(int i = 0; i < q; i++)
    {
        int x1, y1, x2, y2;
        point f; point s;
        scanf("%d %d %d %d", &f.x, &f.y, &s.x, &s.y);
        f.x++; f.y++; s.x++; s.y++;
        if(f.y < s.y)
        {
            swap(f, s);
        }
        if(f.x < s.x)
        {
            int temp = f.y;
            f.y = s.y;
            s.y = temp;
        }
        int ans = T[f.y][f.x] - T[f.y][s.x - 1] - T[s.y - 1][f.x] + T[s.y - 1][s.x - 1];
        printf("%d\n", ans);
    }
}

int main()
{
    read_input();
    make_table();
    solve();

    return 0;
}

/*
6
9 2
2 3
8 6
3 6
5 3
5 8
3
6 9 9 8
2 3 5 8
10 7 4 3

6
2 5
2 3
8 6
3 6
5 3
5 8
3
6 9 9 8
2 3 5 8
10 7 4 3
*/
