#include <iostream>
#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

vector<int> gr[111];
queue<pair<int,int> > x;
int path[111][111],patho[111][111],par[111],mat[111][111],n,m,a,b,top=1,used[111];
bool flag;

void nul()
{
    for(int i=0;i<=n;i++)
    {
        for(int j=0;j<=n;j++)path[i][j]=patho[i][j];
    }
    return;
}

void nullify()
{
    fill(par,par+n+1,-1);
    flag=false;
    return ;
}

bool dfs(int node,int e)
{
    if(node==e)return flag=true;
    used[node]=top;
    for(int i=0;i<gr[node].size();i++)
    {
        if(used[gr[node][i]]!=top && path[node][gr[node][i]]>0)
        {
            par[gr[node][i]]=node;
            dfs(gr[node][i],e);
        }
        if(flag==true)return true;
    }
    if(flag==true)return true;
    return false;
}

int fl(int s,int e)
{
    int flow=0,seg;
    nullify();
    nul();
    while(dfs(s,e)==1)
    {
        top++;
        flow++;
        seg=e;
        flag=false;
        while(par[seg]!=-1)
        {
            //cout<<seg<<" "<<par[seg]<<endl;
            path[seg][par[seg]]++;
            path[par[seg]][seg]--;
            seg=par[seg];
        }
    }
    return flow;
}

int main()
{
    scanf("%d%d",&n,&m);
    for(int i=0;i<m;i++)
    {
        scanf("%d%d",&a,&b);
        gr[a].push_back(b);
        gr[b].push_back(a);
        path[a][b]++;
        path[b][a]++;
        patho[a][b]++;
        patho[b][a]++;
    }
    printf("%d\n",fl(1,n));

    int q,black=0;
    scanf("%d",&q);
    for(int i=0;i<q;i++)
    {
        scanf("%d%d",&a,&b);
        gr[a].push_back(b);
        gr[b].push_back(a);
        path[a][b]++;
        path[b][a]++;
        patho[a][b]++;
        patho[b][a]++;

        if(patho[a][b]<=10)
        {
            black=fl(1,n);
            printf("%d\n",black);
        }
        else printf("%d\n",black);

    }
    return 0;
}

/*



5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0


5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5


5 5
1 2
3 5
5 4
1 5
3 2



*/
