#include<iostream>
#include<vector>
#define endl '\n'

using namespace std;

const int MAXN = 10000;
const int MAXM = 10000;
const int MAXX= 100000;
int n, m;
struct coordinates
{
    int x, y;
};
struct rectcoordinates
{
    coordinates l;
    coordinates r;
};
vector<coordinates> point;
vector<rectcoordinates> rect;
vector<int> t[MAXX+10];
int counter[MAXM+10];

void input()
{
    coordinates a, b;
    cin>>n;
    for (int i=0; i<n; i++)
    {
        cin>>a.x>>a.y;
        point.push_back(a);
    }
    cin>>m;
    for (int i=0; i<m; i++)
    {
        cin>>a.x>>a.y>>b.x>>b.y;
        if (a.x > b.x) swap(a.x, b.x);
        if (a.y > b.y) swap(a.y, b.y);
        rect.push_back({a, b});
    }
}

void output()
{
    for (int i=0; i<m; i++)
    {
        cout<<counter[i]<<endl;
    }
}

void FillTable()
{
    for (int i=0; i<m; i++)
    {
        for (int j=rect[i].l.x; j<=rect[i].r.x; j++)
        {
            t[j].push_back(i);
        }
    }
}

void OutputTable()
{
    for (int i=0; i<10; i++)
    {
        cerr<<i<<" - ";
        for (int j=0; j<t[i].size(); j++)
        {
            cerr<<t[i][j]<<' ';
        }
        cerr<<endl;
    }
}

void CountPoints()
{
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<t[point[i].x].size(); j++)
        {
            if (rect[t[point[i].x][j]].l.y<=point[i].y && rect[t[point[i].x][j]].r.y>=point[i].y) counter[t[point[i].x][j]]++;
        }
    }
}

void solve()
{
    FillTable();
    //OutputTable();
    CountPoints();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
6
9 2
2 3
8 6
3 6
5 3
5 8
3
6 9 9 8
2 3 5 8
10 7 4 3
*/
