# include<iostream>
# include<vector>
# include<queue>
# include<cstring>
using namespace std;

vector<int> g[128],rg[128];
int cap[128][128];
int vis[128];
int parent[128];
int n,m;
vector<int> pat;
bool bfs(vector<int> rg[], int s, int t)
{
    queue<int> path;
    path.push(s);
    pat.push_back(s);
    vis[s]=1;
    while(!path.empty())
    {
        int v=path.front();
        path.pop();
        for(int i=0; i<rg[v].size(); i++)
        {
            if(!vis[rg[v][i]] && cap[v][rg[v][i]]>0)
            {
                vis[rg[v][i]]=1;
                pat.push_back(rg[v][i]);
                 path.push(rg[v][i]);
            }
        }
    }
   //  for(int i=0; i<pat.size(); i++) cout<<pat[i]<<" ";
    if(vis[t]!=0) return true;
    return false;
}

int flow(vector<int> g[])
{
    int fl=0;


    while(bfs(g,1,n))
    {
memset(vis,0,sizeof(vis));
        for(int i=1; i<pat.size()-1; i++)
        {

            int u=pat[i-1];
            int v=pat[i];//cout<<u<<" "<<v<<endl;
            cap[u][v]-=1;
            cap[v][u]+=1;
        }
        pat.clear();
        fl++;

    }

    return fl;
}

int main()
{
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        int x,y;
        cin>>x>>y;
        g[x].push_back(y);
        g[y].push_back(x);
        cap[x][y]++;
        cap[y][x]++;
    }
    int q;
    cin>>q;

    cout<<flow(g)<<endl;

}

