#include<stdio.h>
#include<vector>
#include<algorithm>
using namespace std;
///------------------
struct point
{
    int x,y;
    point(){}
    point(int _x, int _y)
    {
        x=_x;
        y=_y;
    }
    bool operator <(const point &p)const
    {
        return x<p.x;
    }
};
struct rect
{
    point p1,p2;
    int in;
    rect(){}
    rect(point _p1, point _p2, int _in)
    {
        p1=_p1;
        p2=_p2;
        in=_in;
    }
    bool operator<(const rect &r)const
    {
        return p1.x<r.p1.x;
    }
};
///------------------
int n,m;
vector<point>p;
vector<rect>r;
int a[100005];
///********************************************
void read()
{
    int i,x,y;
    point p1,p2;
    scanf("%d",&n);
    for(i=0;i<n;i++)
    {
        scanf("%d%d",&x,&y);
        //cin>>x>>y;
        p.push_back(point(x,y));
    }
    sort(p.begin(),p.end());
    scanf("%d",&m);
    for(i=0;i<m;i++)
    {
        scanf("%d%d",&p1.x,&p1.y);
        //cin>>p1.x>>p1.y;
        scanf("%d%d",&p2.x,&p2.y);
        //cin>>p2.x>>p2.y;
        if(p1.x>p2.x)swap(p1.x,p2.x);
        if(p1.y>p2.y)swap(p1.y,p2.y);
        r.push_back(rect(p1,p2,i));
    }
    sort(r.begin(),r.end());
}
///*******************************************
int find_ans(int i,int j)
{
    int sz=p.size(),ans=0;
    rect tr=r[j];
    for(i;i<sz;i++)
    {
        point p1=p[i];
        if(p1.x>tr.p2.x)break;
        if(p1.y>=tr.p1.y&&p1.y<=tr.p2.y)ans++;
    }
    return ans;
}

///*******************************************
void solve()
{
    int i=0,j=0,psz,rsz,ans=0;
    rect tr;
    point tp;
    psz=p.size();
    rsz=r.size();
    while(i<psz&&j<rsz)
    {
        tp=p[i];
        tr=r[j];
        if(tp.x<tr.p1.x)i++;
        else
        {
            ans=find_ans(i,j);
            a[tr.in]=ans;
            j++;
        }
    }
}

///********************************************
int main()
{
    int i;
	read();
	solve();
	int rsz=r.size();
	for(i=0;i<rsz;i++)
        printf("%d\n",a[i]);
	return 0;
}
/*
6
9 2
2 3
8 6
3 6
5 3
5 8
3
6 9 9 8
2 3 5 8
10 7 4 3
*/
