#include<iostream>
#include<algorithm>

using namespace std;

const int MAXN = 2005;
const long long inf = (1LL<<55);

struct kid
{
    long long h, l;
};

bool operator <(const kid A, const kid B)
{
    if(A.h+A.l!=B.h+B.l) return (A.h+A.l)<(B.h+B.l);
    if(A.h!=B.h) return A.h<B.h;
    return A.l<B.l;
}

int n;
long long d;
kid a[MAXN];


bool used[MAXN];
long long sum = 0;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int inde;
    bool found;

    int answer = 0;

    cin >> n;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i].h >> a[i].l;
        sum += a[i].h;
    }
    cin >> d;

    sort(a, a+n);
    do
    {
        found = false;
        for(int i = 0;i<n;i++)
        {
            if(used[i]==false && sum+a[i].l>=d)
            {
                answer++;
                used[i] = true;

                sum -= a[i].h;

                found = true;
                break;
            }
        }
    }
    while(found==true);

    cout << answer << '\n';
}
