#include<iostream>
#include<cstring>

using namespace std;

const int MAXN = 5*(1e4) + 5;

int n, m;
int a[MAXN], b[MAXN];

int colorA[MAXN], colorB[MAXN];
int sentA[MAXN], sentB[MAXN];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    bool fail = false;

    cin >> n >> m;
    for(int i = 1;i<=n;i++) cin >> a[i];
    for(int i = 1;i<=m;i++) cin >> b[i];

    for(int index = 2;index<=2;index++)
    {
        memset(colorA, 0, sizeof(colorA));
        memset(colorB, 0, sizeof(colorB));

        memset(sentA, 0, sizeof(sentA));
        memset(sentB, 0, sizeof(sentB));

        colorA[ b[index] ] = false;
        colorB[index] = true;

        sentA[ b[index] ] = 1;

        for(int i = 1;i<=n;i++)
        {
            if(sentA[i]==0 && colorB[ a[i] ]==false)
            {
                colorA[i] = true;
                sentB[ a[i] ]++;
            }
        }

        for(int i = 1;i<=m;i++)
        {
            if(colorB[i]==false && sentB[i]==0)
            {
                colorB[i] = true;
                colorA[ b[i] ] = false;

                sentA[ b[i] ]++;
                sentB[ a[ b[i] ] ]--;
            }
        }

        fail = false;
        for(int i = 1;i<=n;i++)
        {
            if(colorA[i]==false && sentA[i]==0)
            {
                fail = true;
                break;
            }
        }
        for(int i = 1;i<=m;i++)
        {
            if(colorB[i]==false && sentB[i]==0)
            {
                fail = true;
                break;
            }
        }

        if(fail==false)
        {
            for(int i = 1;i<=n;i++)
                cout << colorA[i];
            cout << '\n';

            for(int i = 1;i<=m;i++)
                cout << colorB[i];
            cout << '\n';

            return 0;
        }
    }

    cout << "No solution" << '\n';
}
