#include<bits/stdc++.h>

using namespace std;

const int MAXN = 5*(1e4) + 5;

int n, m;
int a[MAXN], b[MAXN];

int colorA[MAXN], colorB[MAXN];
int sentA[MAXN], sentB[MAXN];

vector <int> v;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int index;
    bool fail = false, colorASent, colorBSent;

    cin >> n >> m;
    for(int i = 1;i<=n;i++) cin >> a[i];
    for(int i = 1;i<=m;i++) cin >> b[i];

    for(int i = 1;i<=n;i++)
    {
        v.push_back(i);
    }
    random_shuffle(v.begin(), v.end());

    int start = clock();

    for(int vIndex = 0;vIndex<v.size();vIndex++)
    {
        index = v[vIndex];
        if(double(clock()-start)/CLOCKS_PER_SEC>=0.290) break;

        memset(colorA, 0, sizeof(colorA));
        memset(colorB, 0, sizeof(colorB));

        memset(sentA, 0, sizeof(sentA));
        memset(sentB, 0, sizeof(sentB));

        colorA[ b[index] ] = false;
        colorB[index] = true;

        sentA[ b[index] ] = 1;

        for(int i = 1;i<=n;i++)
        {
            if(sentA[i]==0 && colorB[ a[i] ]==false)
            {
                colorA[i] = true;
                sentB[ a[i] ]++;
            }
        }

        for(int i = 1;i<=m;i++)
        {
            if(colorB[i]==false && sentB[i]==0)
            {
                sentA[ b[i] ]++;
                if(colorA[ b[i] ]==true) sentB[ a[ b[i] ] ]--;

                colorB[i] = true;
                colorA[ b[i] ] = false;
            }
        }

        fail = false;
        colorASent = false;
        colorBSent = false;

        for(int i = 1;i<=n;i++)
        {
            if(colorA[i]==false && sentA[i]==0)
            {
                fail = true;
                break;
            }


            if(colorA[i]==true)
            {
                colorASent = true;
            }
        }
        for(int i = 1;i<=m;i++)
        {
            if(colorB[i]==false && sentB[i]==0)
            {
                fail = true;
                break;
            }

            if(colorB[i]==true)
            {
                colorBSent = true;
            }
        }

        if(fail==false && colorASent==true && colorBSent==true)
        {
            for(int i = 1;i<=n;i++)
                cout << colorA[i];
            cout << '\n';

            for(int i = 1;i<=m;i++)
                cout << colorB[i];
            cout << '\n';

            return 0;
        }
    }

    cout << "No solution" << '\n';
}
