#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int n, m;
bool matrix [100][100];
vector < int > ln [100];

bool mark (int from, int to)
{
	bool visited [100];
	for (int i = 0 ; i < 100 ; i ++) visited [i] = false;
	queue < pair < int, vector < int > > > q;
	q.push ({from, {}});
	visited [from] = true;
	while (!q.empty ())
	{
		auto curr = q.front (); q.pop ();

		if (curr.first == to)
		{
			int prev = from;
			for (auto& x : curr.second)
			{
				matrix [prev][x] = false;
				matrix [x][prev] = false;
				prev = x;
			}
			return true;
		}

		for (auto& x : ln [curr.first])
		{
			if (not visited [x] and matrix [curr.first][x])
			{
				curr.second.push_back (x);
				q.push ({x, curr.second});
				visited [x] = true;
				curr.second.pop_back ();
			}
		}
	}
	return false;
}

void init (int a = 0, int b = 0)
{
	cin >> a >> b;
	a --; b --;
	matrix [a][b] = true;
	matrix [b][a] = true;
	ln [a].push_back (b);
	ln [b].push_back (a);
}

void count_ans ()
{
	int ans = 0;
	for ( ; mark (0, n - 1) ; ans ++) {}
	cout << ans << endl;
}

void recover ()
{
	for (int i = 0 ; i < n ; i ++)
		for (auto& x : ln [i])
			matrix [i][x] = true;
}

int main()
{
	cin.tie(nullptr);
	ios::sync_with_stdio (false);

	cin >> n >> m;
	for (int i = 0 ; i < m ; i ++)
	{
		init ();
	}
	int q;
	cin >> q;
	for (int i = 0 ; i < q ; i ++)
	{
		count_ans ();
		init ();
		recover ();
	}
	count_ans ();
}

