#include <iostream>
#include <vector>

using namespace std;

struct person 
{
	int h, l;
};

vector < person > people;
int trap_h;

int ways (int ind, int h, int used, int max_l)
{
	if (h + max_l >= trap_h)
		return people.size () - used + 1;

	if (ind == people.size ())
		return 0;

	int ans = 0;
	for (int i = ind ; i < people.size () ; i ++)
	{
		ans = max (ans, ways (i + 1, h + people [i].h, used + 1, max (max_l, people [i].l)));
	}
	return ans;
}

int main()
{
	cin.tie(nullptr);
	ios::sync_with_stdio (false);
	int n;
	cin >> n;
	for (int i = 0 ; i < n ; i ++)
	{
		int h, l;
		cin >> h >> l;
		people.push_back ({h, l});
	}
	cin >> trap_h;
//	sort (people.begin (), people.end (), [](person a, person b) { return a.h + a.
	cout << ways (0, 0, 0, 0) << endl;
}

