#include <iostream>
#include <vector>
#include <queue>

int n, m;
std::vector<std::vector<int>> v;
bool used[128][128];

int main() {
    std::cin >> n >> m;
    v.resize(n);
    for(int i = 0; i < m; i++) {
        int s, e;
        std::cin >> s >> e;
        v[--s].push_back(--e);
        v[e].push_back(s);
    }
    std::queue<int> q;
    q.push(0);
    int cnt = 0;
    while(!q.empty()) {
        int sq = q.front();
        q.pop();
        for(auto &x: v[sq]) {
            if(!used[sq][x]) {
                if(x == n-1) {
                    cnt++;
                } else
                    q.push(x);
                used[sq][x] = true;
                used[x][sq] = true;
            }
        }
    }
    std::cout << cnt << "\n";
    return 0;
}
