#include <iostream>
#include <vector>
#include <queue>

int n, m;
std::vector<std::vector<int>> v;
bool used[128][128];

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cin >> n >> m;
    v.resize(n);
    for(int i = 0; i < m; i++) {
        int s, e;
        std::cin >> s >> e;
        v[--s].push_back(--e);
        v[e].push_back(s);
    }
    int Q;
    std::cin >> Q;
GULAG:
    std::queue<int> q;
    q.push(0);
    int cnt = 0;
    for(int i = 0; i <n; i++) {
        for(int j = 0; j < n; j++) {
            used[i][j] = false;
        }
    }
    while(!q.empty()) {
        int sq = q.front();
        q.pop();
        for(auto &x: v[sq]) {
            if(!used[sq][x]) {
                if(x == n-1) {
                    cnt++;
                } else
                    q.push(x);
                used[sq][x] = true;
                used[x][sq] = true;
            }
        }
    }
    std::cout << cnt << "\n";
    if(Q > 0) {
        --Q;
        int a, b;
        std::cin >> a >> b;
        v[--a].push_back(--b);
        v[b].push_back(a);
        goto GULAG;
    }
    return 0;
}
