#include <iostream>
#include <ctime>
#include <cstdlib>
#include <chrono>
#include <vector>

int m, n;
std::vector<int> v1, v2;
std::vector<bool> b1, b2;

bool correct() {
    int cp1 = 0, cp2 = 0;
    for(int i = 0; i < m; i++) {
        if(b1[i]) {
            cp1++;
            if(b2[v1[i]]) {
                return false;
            }
        }
    }
    for(int i = 0; i < n; i++) {
        if(b2[i]) {
            cp2++;
            if(b1[v2[i]]) {
                return false;
            }
        }
    }
    if(cp1 == 0 || cp2 == 0) {
        return false;
    }
    return true;
}

int main() {
    auto start = std::chrono::system_clock::now();
    srand(time(NULL));
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cin >> m >> n;
    v1.resize(m);
    v2.resize(n);
    b1.resize(m);
    b2.resize(n);
    for(int i = 0; i < m; i++) {
        int blq;
        std::cin >> blq;
        v1[i] = --blq;

    }
    for(int j = 0; j < n; j++) {
        int blq;
        std::cin >> blq;
        v2[j] = --blq;
    }
    while(true) {
        std::chrono::duration<double> diff = std::chrono::system_clock::now() - start;
        for(int i = 0; i < n; i++) {
            if(rand() % 10 == 0) {
                b2[i] = !b2[i];
            }
        }
        for(int i = 0; i < n; i++) {
            if(rand() % 10 == 0) {
                b1[i] = !b1[i];
            }
        }
        if(diff.count() >= 100 || correct()) {
            for(auto x: b1)
                std::cout << x;
            std::cout << "\n";
            for(auto x: b2)
                std::cout << x;
            std::cout << "\n";
            return 0;
        }
    }
    return 0;
}
