#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

#define x first
#define y second

std::vector<std::pair<int, int>> v;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n;
    std::cin >> n;
    for(int i = 0; i < n; i++) {
        int a, b;
        std::cin >> a >> b;
        v.push_back({a, b});
    }
    std::sort(std::begin(v), std::end(v));
    int m;
    std::cin >> m;
    for(int i = 0; i < m; i++) {
        int _x1, _y1, _x2, _y2;
        std::cin >> _x1 >> _y1 >> _x2 >> _y2;
        int x1 = std::min(_x1, _x2),
            x2 = std::max(_x1, _x2),
            y1 = std::min(_y1, _y2),
            y2 = std::max(_y1, _y2);
        int cnt = 0;
        for(int j = 0; j < v.size(); j++) {
            if (v[j].x > x2)
                break;
            if(v[j].x >= x1 && v[j].y <= y2 && v[j].y >= y1) {
                cnt++;
            }
        }
        std::cout << cnt << "\n";
    }
    return 0;
}
