#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

pair <int, int> A[2005];
int idx[2005];

bool cmp (pair <int, int> a, pair <int, int> b)
{
    if (a.first != b.first)
    {
        return a.first > b.first;
    }
    return a.second > b.second;
}

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int s = 0;

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> A[i].first >> A[i].second;
        idx[i] = i;
    }

    int d;
    cin >> d;

    for (int i = 0; i < n; ++i)
    {
        if (A[i].first + A[i].second >= d)
        {
            idx[s] = i;
            idx[i] = s;
            ++s;
        }
    }

    int res = 0;
    do
    {
        int curr = 0;
        int l = 0, br;
        for (br = 0; br < n; ++br)
        {
            l += A[idx[br]].first;
            if (l >= d)
            {
                curr = n - br - 1;
                break;
            }
        }
        for (; br >= 0; --br)
        {
            if (l + A[idx[br]].second >= d)
            {
                ++curr;
                l -= A[idx[br]].first;
            }
        }

        if (curr > res)
        {
            res = curr;
        }
    } while (next_permutation(idx + s, idx + n) and res != n);

    cout << res << '\n';
    return 0;
}
