#include <iostream>
#include <set>

using namespace std;

int A[50005], B[50005];
int n, m;
set<int> a, b;
bool resA[50005], resB[50005];
bool solvedA[50005], solvedB[50005];
int brSolvedA, brSolvedB;


int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    cin >> n >> m;

    for (int i = 0; i < n; ++i)
    {
        cin >> A[i];
        --A[i];
        a.insert(A[i]);
    }

    for (int i = 0; i < m; ++i)
    {
        cin >> B[i];
        --B[i];
        b.insert(B[i]);
    }

    for (int i = 0; i < n; ++i)
    {
        if (b.find(i) == b.end())
        {
            solvedA[i] = true;
            resA[i] = true;

            if (!solvedB[A[i]])
            {
                ++brSolvedB;
            }
            solvedB[A[i]] = true;

            ++brSolvedA;
        }
    }
    for (int i = 0; i < m; ++i)
    {
        if (a.find(i) == a.end())
        {
            solvedB[i] = true;
            resB[i] = true;

            if (!solvedA[B[i]])
            {
                ++brSolvedA;
            }
            solvedA[B[i]] = true;

            ++brSolvedB;
        }
    }

    if ((brSolvedA == n and brSolvedB != m) or (brSolvedA != n and brSolvedB == m))
    {
        cout << "No solution\n";
        return 0;
    }
    if (brSolvedA == n and brSolvedB == m)
    {
        for (int i = 0; i < n; ++i)
        {
            cout << resA[i];
        }
        cout << '\n';
        for (int i = 0; i < m; ++i)
        {
            cout << resB[i];
        }
        cout << '\n';
        return 0;
    }

    while (true)
    {
        if (n < m)
        {
            for (int i = 0; i < m; ++i)
            {
                if (!solvedB[i])
                {

                    resB[i] = true;
                }
            }
            for (int i = 0; i < n; ++i)
            {
                if (resA[i] == true)
                {
                    if (!solvedB[A[i]])
                    {
                        resB[A[i]] = false;
                    }
                }
            }
        }
        else
        {
            for (int i = 0; i < n; ++i)
            {
                if (!solvedA[i])
                {

                    resA[i] = true;
                }
            }
            for (int i = 0; i < m; ++i)
            {
                if (resB[i] == true)
                {
                    if (!solvedA[B[i]])
                    {
                        resA[B[i]] = false;
                    }
                }
            }
        }

        /*cout << "try:\n   ";
        for (int i = 0; i < n; ++i)
        {
            cout << resA[i];
        }
        cout << "\n   ";
        for (int i = 0; i < m; ++i)
        {
            cout << resB[i];
        }
        cout << "...\n";*/
        bool ok = true;
        bool usedA[50005], usedB[50005];
        for (int i = 0; i < n; ++i)
        {
            usedA[i] = false;
        }
        for (int i = 0; i < m; ++i)
        {
            usedB[i] = false;
        }
        int uA = 0, uB = 0;
        for (int i = 0; i < n and ok; ++i)
        {
            if (resA[i])
            {
                usedA[i] = true;
                ++uA;
                if (resB[A[i]])
                {
                    ok = false;
                    break;
                }
                if (!usedB[A[i]])
                {
                    usedB[A[i]] = true;
                    ++uB;
                }
            }
        }
        for (int i = 0; i < m and ok; ++i)
        {
            if (resB[i])
            {
                usedB[i] = true;
                ++uB;
                if (resA[B[i]])
                {
                    ok = false;
                    break;
                }
                if (!usedA[B[i]])
                {
                    usedA[B[i]] = true;
                    ++uA;
                }
            }
        }
        /*for (int i = 0; i < n; ++i)
        {
            cout << usedA[i];
        }
        cout << ' ';
        for (int i = 0; i < m; ++i)
        {
            cout << usedB[i];
        }
        cout << ' ' << ok << ' ' << uA << ' ' << n << ' ' << uB << ' ' << m << '\n';*/
        if (ok and uA == n and uB == m)
        {
            for (int i = 0; i < n; ++i)
            {
                cout << resA[i];
            }
            cout << '\n';
            for (int i = 0; i < m; ++i)
            {
                cout << resB[i];
            }
            cout << '\n';
            return 0;
        }

        if (n < m)
        {
            int p = 1;
            for (int i = n - 1; p == 1 and i >= 0; --i)
            {
                if (!solvedA[i])
                {
                    if (!resA[i])
                    {
                        resA[i] = true;
                        p = 0;
                    }
                    else
                    {
                        resA[i] = false;
                    }
                }
            }
            if (p == 1)
            {
                cout << "No solution\n";
                return 0;
            }
        }
        else
        {
            int p = 1;
            for (int i = m - 1; p == 1 and i >= 0; --i)
            {
                if (!solvedB[i])
                {
                    if (!resB[i])
                    {
                        resB[i] = true;
                        p = 0;
                    }
                    else
                    {
                        resB[i] = false;
                    }
                }
            }
            if (p == 1)
            {
                cout << "No solution\n";
                return 0;
            }
        }
    }

    return 0;
}
