#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int n, m;
bool M[105][105];
vector<int> A[105];

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        A[a].push_back(b);
        A[b].push_back(a);
        M[a][b] = true;
        M[b][a] = true;
    }

    int q;
    cin >> q;
    int res = 0;
    for (int qq = 0; qq <= q; ++qq)
    {
        if (qq != 0)
        {
            int a, b;
            cin >> a >> b;
            A[a].push_back(b);
            A[b].push_back(a);
            M[a][b] = true;
            M[b][a] = true;
        }

        queue<int> que;
        que.push(1);
        while (!que.empty())
        {
            int curr = que.front();
            que.pop();

            for (int i = 0; i < A[curr].size(); ++i)
            {
                if (M[curr][A[curr][i]])
                {
                    if (A[curr][i] == n)
                    {
                        ++res;
                    }
                    else
                    {
                        que.push(A[curr][i]);
                    }

                    M[curr][A[curr][i]] = false;
                    M[A[curr][i]][curr] = false;
                }
            }
        }

        cout << res << '\n';
    }

    return 0;
}

