#include <iostream>
#include <vector>
#include <queue>
using namespace std;
const int maxM=100010;
struct edge{
    int b,e;
    bool used;
    edge(){
        used=0;
    }
}edges[maxM];
struct node{
    int v,ind;
    node(){}
    node(int a,int i){
        v=a;
        ind=i;
    }
};
vector<node> graph[200];
int n,m,q,used[200];
bool fl;
void bfs(int s)
{
    int i;
    int lev[200];
    node par[200];
    for(i=0;i<=n;i++){
        used[i]=0;
        par[i].v=0;
        par[i].ind=-1;
        lev[i]=0;
    }
    lev[s]=1;
    queue<int> q;
    int tmp;
    q.push(s);
    while(!q.empty())
    {
        tmp=q.front();
        q.pop();
        if(used[tmp]==1)continue;
        used[tmp]=1;
        for(i=0;i<graph[tmp].size();i++)
        {
            if(!used[graph[tmp][i].v] && edges[graph[tmp][i].ind].used==0)
            {
                q.push(graph[tmp][i].v);
                if(lev[graph[tmp][i].v]==0)
                {
                    par[graph[tmp][i].v].v=tmp;
                    par[graph[tmp][i].v].ind=graph[tmp][i].ind;
                    lev[graph[tmp][i].v]=lev[tmp]+1;
                }
            }
        }
    }
    i=n;
    while(i>=1)
    {
        edges[par[i].ind].used=1;
        i=par[i].v;
    }
}
void calc()
{
    int cnt=0;
    while(1)
    {
        bfs(1);
        if(used[n]==0)break;
        cnt++;
    }
    cout<<cnt<<endl;
    for(int i=0;i<m;i++)
    {
        edges[i].used=0;
    }
}
int main()
{
    int i,j;
    cin>>n>>m;
    for(i=0;i<m;i++)
    {
        cin>>edges[i].b>>edges[i].e;
        graph[edges[i].b].push_back(node(edges[i].e,i));
        graph[edges[i].e].push_back(node(edges[i].b,i));
    }
    cin>>q;
    calc();
    for(i=1;i<=q;i++)
    {
        cin>>edges[m].b>>edges[m].e;
        graph[edges[m].b].push_back(node(edges[m].e,m));
        graph[edges[m].e].push_back(node(edges[m].b,m));
        m++;
        calc();
    }
}
/**
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0
-----
5 4
1 2
3 5
5 4
1 4
3
3 2
1 3
2 5
*/
