#include <iostream>
#include <vector>
#include <queue>
using namespace std;
const int maxM=100010;
const int INF=100000;
struct node{
    int v,ind;
    int flow,cap;
    node(){}
    node(int a,int f,int c,int i){
        v=a;
        flow=f;
        cap=c;
        ind=i;
    }
};
vector<node> graph[200];
int n,m,q,used[200];
int max_flow=0;
node par[200];
void bfs(int s)
{
    int i;
    for(i=0;i<=n;i++)
    {
        used[i]=0;
        par[i].v=0;
        par[i].ind=0;
    }
    queue<int> q;
    int tmp;
    q.push(s);
    while(!q.empty())
    {
        tmp=q.front();
        q.pop();
        if(used[tmp]==1)continue;
        used[tmp]=1;
        for(i=0;i<graph[tmp].size();i++)
        {
            if(!used[graph[tmp][i].v] && graph[tmp][i].flow<graph[tmp][i].cap)
            {
                q.push(graph[tmp][i].v);
                par[graph[tmp][i].v].v=tmp;
                par[graph[tmp][i].v].ind=i; ///graph[tmp][i].ind;
            }
        }
    }
}
void calc()
{
    while(1)
    {
        bfs(1);
        if(used[n]==0)break;
        int tmp=INF;
        int i=n;
        while(i>1)
        {
            tmp=min(tmp,graph[par[i].v][par[i].ind].cap-graph[par[i].v][par[i].ind].flow);
            graph[par[i].v][par[i].ind].flow+=tmp;
            graph[i][graph[par[i].v][par[i].ind].ind].flow-=tmp;
            i=par[i].v;

        }
        max_flow+=tmp;
    }
    cout<<max_flow<<endl;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int i,j,b,e;
    cin>>n>>m;
    for(i=0;i<m;i++)
    {
        cin>>b>>e;
        graph[b].push_back(node(e,0,1,graph[e].size()));
        graph[e].push_back(node(b,0,0,graph[b].size()-1));
        graph[e].push_back(node(b,0,1,graph[b].size()));
        graph[b].push_back(node(e,0,0,graph[e].size()-1));
    }
    cin>>q;
    calc();
    for(i=1;i<=q;i++)
    {
        cin>>b>>e;
        graph[b].push_back(node(e,0,1,graph[e].size()));
        graph[e].push_back(node(b,0,0,graph[b].size()-1));
        graph[e].push_back(node(b,0,1,graph[b].size()));
        graph[b].push_back(node(b,0,0,graph[b].size()-1));
        m++;
        calc();
    }
}
/**
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0
-----
5 4
1 2
3 5
5 4
1 4
3
3 2
1 3
2 5
*/

