#include <iostream>
#include <vector>
using namespace std;
const int maxN=50010;
int n,m;
struct node
{
    int v,ind;
    bool f;
    bool used;
    node() {}
    node(int a,int i,bool p)
    {
        v=a;
        ind=i;
        f=p;
        used=0;
    }
};
vector<node> graph[2*maxN];
int vid[2*maxN];
int cntEdges(int i)
{
    int cnt=0;
    for(int j=0;j<graph[i].size();j++)
    {
        if(graph[i][j].used==0)cnt++;
    }
    return cnt;
}
int edge(int i)
{
    for(int j=0;j<graph[i].size();j++)
    {
        if(graph[i][j].used==0)return j;
    }
}
int cntNodes()
{
    int cnt=0;
    for(int i=1;i<=m+n;i++)
    {
        if(vid[i]==-1)cnt++;
    }
    return cnt;
}
int main()
{
    int i,b,e,j;
    cin>>m>>n;
    for(i=1; i<=m; i++)
    {
        cin>>e;
        graph[i].push_back(node(m+e,graph[m+e].size(),1));
        graph[m+e].push_back(node(i,graph[i].size()-1,0));
    }
    for(i=1; i<=n; i++)
    {
        cin>>e;
        graph[m+i].push_back(node(e,graph[e].size(),1));
        graph[e].push_back(node(m+i,graph[m+i].size(),0));
    }
    if(m==1 || n==1)
    {
        cout<<"No solution\n";
        return 0;
    }
    for(i=1; i<=m+n; i++)vid[i]=-1;
    for(i=1; i<=m+n; i++)
        {
            if(graph[i].size()==1)
            {
                vid[i]=1;
                vid[graph[i][0].v]=0;
                graph[i][0].used=1;
                graph[graph[i][0].v][graph[i][0].ind].used=1;
            }
        }
    for(i=1;i<=m+n;i++)
    {
        if(vid[i]!=0)continue;
        for(j=0;j<graph[i].size();j++)
        {
            if(graph[i][j].f==1){
                graph[i][j].used=1;
                graph[graph[i][j].v][graph[i][j].ind].used=1;
            }
        }
    }
    bool fl;
    while(cntNodes()>0)
    {
        fl=0;
        for(i=1;i<=m+n;i++)
        {
            if(vid[i]!=-1)continue;
            if(cntEdges(i)==1){
                fl=1;
                int ind=edge(i);
                vid[i]=graph[i][ind].f;
                if(vid[graph[i][ind].v]==-1)
                {
                    vid[graph[i][ind].v]=(graph[i][ind].f^1);
                }
            }
        }
        for(i=1;i<=m+n;i++)
        {
            if(vid[i]==-1)continue;
            for(j=0;j<graph[i].size();j++)
            {
                if(graph[i][j].f==(vid[i]^1)){
                    graph[i][j].used=1;
                    graph[graph[i][j].v][graph[i][j].ind].used=1;
                }
            }
        }
        if(fl==0)
        {
            cout<<"No solution\n";
            return 0;
        }
    }
    for(i=1;i<=m;i++)
    {
        cout<<vid[i];
    }cout<<endl;
    for(i=m+1;i<=m+n;i++)
    {
        cout<<vid[i];
    }cout<<endl;
}
/**
5 4
4 4 4 1 3
3 5 2 5
*/
