#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <queue>
using namespace std;

int n,m,from,to,cnt,way[102],ways[102][102],cur,maxbr1,ans=0,q;
vector<int> nb[102];
bool used[102],used_way[102][102];

void dfs(int s)
{
    if(s==n)
    {
        ways[cur][0]=cnt;
        for(int i=0;i<cnt;i++)
            ways[cur][i+1]=way[i];
        cur++;
        return;
    }
    for(int i=0;i<nb[s].size();i++)
    {
        if(used[nb[s][i]]==1)continue;
        way[cnt++]=nb[s][i];
        used[nb[s][i]]=1;
        dfs(nb[s][i]);
        used[nb[s][i]]=0;
        cnt--;
    }
}

void rec(string s)
{
    if(s.size()==cur)
    {
        for(int i=0;i<15;i++)
            for(int j=0;j<15;j++)
                used_way[i][j]=0;
        int br1=0;
        for(int i=0;i<s.size();i++)
        {
            if(s[i]=='1')
            {
                for(int j=1;j<ways[i][0];j++)
                {
                    if(used_way[ways[i][j]][ways[i][j+1]]==1)return;
                    else used_way[ways[i][j]][ways[i][j+1]]=1,
                         used_way[ways[i][j+1]][ways[i][j]]=1;
                }
                br1++;
            }
        }
        if(br1>maxbr1)maxbr1=br1;
        return;
    }

    rec(s+"0");
    rec(s+"1");
}


void bfs(int s)
{
    ans=0;
    queue<int> q;
    q.push(s);
    for(int i=1;i<=n;i++)
        used[i]=0;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
        {
            used_way[i][j]=0;
            used_way[j][i]=0;
        }

    while(!q.empty())
    {
        int tmpv=q.front();
        ///cout<<tmpv<<endl;
        //cout<<tmpv<<endl;
        //system("PAUSE");
        q.pop();

        if(tmpv==n)
        {
            ans++;
            continue;
        }

        if(used[tmpv]==1)continue;
        used[tmpv]=1;

        for(int i=0;i<nb[tmpv].size();i++)
        {
            if(used[nb[tmpv][i]]==1||used_way[tmpv][nb[tmpv][i]]==1)continue;
            q.push(nb[tmpv][i]);
        }
    }
}

int main()
{
    scanf("%d%d",&n,&m);

    for(int i=0;i<m;i++)
    {
        scanf("%d%d",&from,&to);
        nb[from].push_back(to);
        nb[to].push_back(from);
    }

    /**if(n<=5)
    {
        way[cnt++]=1;
        used[1]=1;
        dfs(1);

        rec("");

        printf("%d\n",maxbr1);
        return 0;
    }*/

    bfs(1);
    printf("%d\n",ans);

    scanf("%d",&q);

    for(int i=0;i<q;i++)
    {
        scanf("%d%d",&from,&to);
        nb[from].push_back(to);
        nb[to].push_back(from);
        bfs(1);
        printf("%d\n",ans);
        ///cout<<endl;
    }

    return 0;
}
/**
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0
*/
/**
5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5
*/
