#include<iostream>
#include<vector>
#define endl '\n'

using namespace std;

const long long MAXN = 50000;
const long long MAXM = 50000;
long long n, m;
long long con1[MAXN+100], con2[MAXM+100];
vector<long long> bcon1[MAXN+100], bcon2[MAXM+100];
short cp1[MAXN+100], cp2[MAXM+100];
bool sol = 1;

void input()
{
    cin>>n>>m;
    for (long long i=0; i<n; i++)
    {
        cin>>con1[i];
        con1[i]--;
        bcon2[con1[i]].push_back(i);
    }
    for (long long i=0; i<m; i++)
    {
        cin>>con2[i];
        con2[i]--;
        bcon1[con2[i]].push_back(i);
    }
}

void outputt(short temp)
{
    if (temp == 3 || temp == 2) cout<<0;
    else cout<<1;
}

void output()
{
    if (!sol)
    {
       cout<<"No solution\n";
    }
    else
    {
        for (long long i=0; i<n; i++)
        {
            outputt(cp1[i]);
        }
        cout<<endl;
        for (long long i=0; i<m; i++)
        {
            outputt(cp2[i]);
        }
        cout<<endl;
    }
}

void dfs(long long cur)
{
    if (cp2[cur] == 3)
    {
        if (bcon2[cur].empty()) sol = 0;
        return;
    }
    if (cp2[cur] == 1) return;
    if (bcon2[cur].empty())
    {
        cp2[cur] = 1;
        cp1[con2[cur]] = 3;
        for (long long j=0; j<bcon2[con1[con1[con2[cur]]]].size(); j++)
        {
            if (bcon2[con1[con2[cur]]][j] == con2[cur])
            {
                swap(bcon2[con1[con2[cur]]][j], bcon2[con1[con2[cur]]][bcon2[con1[con2[cur]]].size()-1]);
                bcon2[con1[con2[cur]]].pop_back();
            }
        }
        dfs(con1[con2[cur]]);
    }
}

void solve()
{
    for (long long i=0; i<n; i++)
    {
        cp1[i] = 1;
        if (!cp2[con1[i]])cp2[con1[i]] = 2;
        if (bcon1[i].empty())
        {
            cp2[con1[i]] = 3;
        }

    }
    /*for (long long i=0; i<m; i++)
    {
        cout<<cp2[i];
    }cout<<endl;*/
    for (long long i=0; i<m; i++)
    {
        dfs(i);
        if (!sol) break;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
5 4
4 4 4 1 3
3 5 2 5
*/
