# include<iostream>
# include<vector>
# include<queue>
# include<cstring>
using namespace std;

vector<int> g[128],rg[128];
int cap[128][128],rcap[128][128];
int vis[128];
int parent[128];
int n,m;
vector<int> path;
vector<int> q;
bool f=0;
void dfs(int u, int last)
{
    vis[u]=1;
    if(f) return;

    if(u==n)
    {
        path.push_back(1);
        for(int i=0; i<q.size(); i++)
        {
            path.push_back(q[i]);
        }
        f=1;
        return;
    }


    for(int i=0; i<g[u].size(); i++)
    {
        if(!vis[g[u][i]] && cap[u][g[u][i]]>0)
        {
            q.push_back(g[u][i]);
            dfs(g[u][i],u);
            q.pop_back();
        }
    }
}

int flow(vector<int> g[])
{
    int fl=0;

    //for(int i=0; i<=n; i++)
     //   for(int j=0; j<=n; j++) rcap[i][j]=cap[i][j];
    //path.push_back(1);
    memset(vis,0,sizeof(vis));
    dfs(1,1);
    while(f==1)
    {
       // cout<<endl;
        vis[n]=0;
        for(int i=1; i<=path.size()-1; i++)
        {

            int u=path[i-1];
            int v=path[i];
            cap[u][v]-=1;
            cap[v][u]+=1;
        }
        path.clear();
        fl++;
        f=0;
        memset(vis,0,sizeof(vis));

        dfs(1,1);
    }

    return fl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        int x,y;
        cin>>x>>y;
        g[x].push_back(y);
        g[y].push_back(x);
        cap[x][y]++;
        cap[y][x]++;
    }
    int q;
    cin>>q;
    int ans=flow(g);
    cout<<ans<<endl;
    for(int i=0; i<q; i++)
    {
        int x,y;
        cin>>x>>y;
        cap[x][y]++;
        cap[y][x]++;
        g[x].push_back(y);
        g[y].push_back(x);
        ans=ans+flow(g);
        cout<<ans<<endl;
    }
}
/*
7 12
1 2
1 3
1 5
1 4
2 3
3 5
5 7
1 7
4 7
3 7
3 6
1 2
*/
