#include <iostream>
#include <cmath>
#include <cctype>
#include <string>
#include <algorithm>
#include <utility>
#include <vector>
#include <queue>
#define MAXN 100002
using namespace std;

int n, m;
int ans[MAXN];

struct Point
{
    int x, y;
};
Point a[MAXN];

struct Rect
{
    int x1, y1, x2, y2;
};
Rect rc [MAXN];

void Init ()
{
    cin>>n;
    for (int i=0; i<n; i++)
    {
        cin>>a[i].x>>a[i].y;
    }
    cin>>m;
    for (int i=0; i<m; i++)
    {
        cin>>rc[i].x1>>rc[i].y1>>rc[i].x2>>rc[i].y2;
        if (rc[i].x1>rc[i].x2) swap (rc[i].x1, rc[i].x2);
        if (rc[i].y1>rc[i].y2) swap (rc[i].y1, rc[i].y2);
        ans[i]=0;
    }
}

void Solve ()
{
    for (int i=0; i<n; i++)
        for (int j=0; j<m; j++)
            if (a[i].x>=rc[j].x1 && a[i].x<=rc[j].x2 && a[i].y>=rc[j].y1 && a[i].y<=rc[j].y2)
                ans[j]++;
    for (int i=0; i<m; i++)
        cout<<ans[i]<<endl;
}

int main ()
{
    Init ();
    Solve ();
    return 0;
}
