#include<bits/stdc++.h>

using namespace std;

const int MAXN = 2005;
const long long inf = (1LL<<55);

struct kid
{
    long long h, l;
};

bool cmp1(const kid A, const kid B)
{
    if(A.h+A.l!=B.h+B.l) return (A.h+A.l)<(B.h+B.l);
    if(A.h!=B.h) return A.h<B.h;
    return A.l<B.l;
}

bool cmp2(const kid A, const kid B)
{
    if(A.l!=B.l) return A.l<B.l;
    return A.h<B.h;
}

bool cmp3(const kid A, const kid B)
{
    if(A.h!=B.h) return A.h<B.h;
    return A.l<B.l;
}

int n;
long long d;
kid a[MAXN];

bool used[MAXN];
long long sum = 0;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    bool found;
    long long sum1 = 0;

    int start;
    int current = 0, answer = -1;

    cin >> n;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i].h >> a[i].l;
        sum1 += a[i].h;
    }
    cin >> d;

    start = clock();

    //1

    sum = sum1;
    current = 0;
    sort(a, a+n, cmp1);
    for(int i = 0;i<n;i++)
    {
        if(used[i]==false && sum+a[i].l>=d)
        {
            current++;
            used[i] = true;

            sum -= a[i].h;
        }
    }
    answer = max(answer, current);

    //2

    sum = sum1;
    current = 0;
    sort(a, a+n, cmp2);
    for(int i = 0;i<n;i++)
    {
        if(used[i]==false && sum+a[i].l>=d)
        {
            current++;
            used[i] = true;

            sum -= a[i].h;
        }
    }
    answer = max(answer, current);

    //3

    sum = sum1;
    current = 0;
    sort(a, a+n, cmp3);
    for(int i = 0;i<n;i++)
    {
        if(used[i]==false && sum+a[i].l>=d)
        {
            current++;
            used[i] = true;

            sum -= a[i].h;
        }
    }
    answer = max(answer, current);

    while(double(clock()-start)/CLOCKS_PER_SEC<=0.185)
    {
        random_shuffle(a, a+n);

        sum = sum1;
        current = 0;
        for(int i = 0;i<n;i++)
        {
            if(used[i]==false && sum+a[i].l>=d)
            {
                current++;
                used[i] = true;

                sum -= a[i].h;
            }
        }
        answer = max(answer, current);
    }

    cout << answer << '\n';
}
