#include<bits/stdc++.h>
const int MAXN=200;
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
#pragma GCC optimize("unroll-loops")
using namespace std;

// g++ -O2 -std=c++11 -o zad zad.cpp
// ./zad
//alt tab

set<int> G[MAXN];
int n, m, q;
void add(int u, int v) {G[u].insert(v); G[v].insert(u);}
void rem(int u, int v) {G[u].erase(v); G[v].erase(u);}

int used[MAXN], par[MAXN];
queue<int> C;
bool bfs()
{
	for(int i=1; i<=n; i++) used[i]=0, par[i]=-1;
	used[1]=1;
	C.push(1);
	while(C.size())
	{
		int u=C.front();
		C.pop();
		for(int x: G[u])
			 if(!used[x]) 
			 {
				 used[x]=1, C.push(x), par[x]=u;
				 if(x==n) return 1;
			 }
	}
	
	return 0;
}

int flow()
{
	int fl=0;
	while(bfs())
	{
		int temp=n;
		while(temp!=1) rem(par[temp], temp), temp=par[temp];
		fl++;
		while(C.size()) C.pop();
	}
	return fl;
}

vector<pair<int, int>> edges;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie();
	
	cin>>n>>m;
	while(m--)
	{
		int x, y;
		cin>>x>>y;
		add(x, y);
		edges.push_back({x, y});
	}
	cin>>q;
	cout<<flow()<<endl;
	while(q--)
	{
		int x, y;
		cin>>x>>y;
		edges.push_back({x, y});
		for(int i=1; i<n; i++) G[i].clear();
		for(int i=0; i<edges.size(); i++) add(edges[i].first, edges[i].second);
		cout<<flow()<<endl;
	}
}

/*
 5 7
  1 2
  3 5
  5 4
  1 5
  3 2
  1 3
  2 5
  *
  5 4
  1 2
  3 5
  5 4
  1 5
  3
  3 2
  1 3
  2 5
  
 */
